// kiln_control by George Odom at email: twincreeksbrewing@austin.rr.com                    // I2C device class (I2Cdev) demonstration Arduino sketch for ADS1115 class
// Reading two differential inputs of the ADS1115 and showing the value in mV

#include <Keypad.h>
#include "ADS1115.h"
#include "math.h"
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4);  // set the LCD address to 0x27 for a 16 chars and 2 line display

float sp = 0; //1350;
float temp, temp3, fdc;
short int pwr = 11;
short int dc;  // , dch, dcl;
short int rate = 7;
short int ldc = 28;
short int count = 520;  //final hold time counter
short int ftype;
String inputString;
String ckString;
long inputInt;
bool flag1 = false;  // 1020 F flag
bool flag2 = false;  // 1250 F flag
bool flaga = false;  // anneal complete flag

const int ROW_NUM = 4; //four rows
const int COLUMN_NUM = 4; //four columns

char keys[ROW_NUM][COLUMN_NUM] = {
  {'1','2','3', 'A'},
  {'4','5','6', 'B'},
  {'7','8','9', 'C'},
  {'*','0','#', 'D'}
};

byte pin_rows[ROW_NUM] = {10, 9, 8, 7}; //connect to the row pinouts of the keypad
byte pin_column[COLUMN_NUM] = {6, 5, 4, 3}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );

// declare an SSD1306 display object connected to I2C
//Adafruit_SSD1306 lcd(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

ADS1115 adc0(ADS1115_DEFAULT_ADDRESS);

// Wire ADS1115 ALERT/RDY pin to Arduino pin 2
const int alertReadyPin = 2;

void setup() {
 
  //I2Cdev::begin();  // join I2C bus
  Wire.begin();
  Serial.begin(57600); // initialize serial communication
  
  pinMode(pwr, OUTPUT);

  Serial.println("Testing device connections...");
  Serial.println(adc0.testConnection() ? "ADS1115 connection successful" : "ADS1115 connection failed");

  adc0.initialize(); // initialize ADS1115 16 bit A/D chip

  // We're going to do single shot sampling
  adc0.setMode(ADS1115_MODE_SINGLESHOT);

  // Slow things down so that we can see that the "poll for conversion" code works
  adc0.setRate(ADS1115_RATE_8);

  // ALERT/RDY pin will indicate when conversion is ready

  pinMode(alertReadyPin, INPUT_PULLUP);
  adc0.setConversionReadyPinMode();

  // To get output from this method, you'll need to turn on the
  //#define ADS1115_SERIAL_DEBUG // in the ADS1115.h file
  /*    #ifdef ADS1115_SERIAL_DEBUG
      adc0.showConfigRegister();
      Serial.print("HighThreshold="); Serial.println(adc0.getHighThreshold(),BIN);
      Serial.print("LowThreshold="); Serial.println(adc0.getLowThreshold(),BIN);
      #endif  
  */

  delay(2000);         // wait for initializing
  
  lcd.init(); // clear display
  //delay(1000);
  lcd.backlight();
  lcd.setCursor(0, 0);       // position to display
  lcd.print("Enter SP:");
  //lcd.print(temp3,0);
 
  
 Serial.println("Enter Set Point Temp"); 

//inputString.reserve(10); // maximum number of digit for a number is 10, change if needed

 while (ckString != "D") {
  char key = keypad.getKey();
  ckString = key;
  if (ckString == "A") {
    ldc =28;
   // rate = 7;
    ftype = 1;
    lcd.setCursor(9, 1);
       lcd.print("rate:0 ");
       //lcd.setCursor(15, 1);
       //lcd.print(rate);
   }
  if (ckString == "B"){ 
    ldc =28;
  //  rate = 7;
    ftype = 2;
   // count2 = 1200;
    flag2 = true;
    lcd.setCursor(9, 1);
       lcd.print("rate:H2");
       //lcd.setCursor(15, 1);
       //lcd.print(rate);
   } 
  if (ckString == "C"){ 
    ldc =28;
  //  rate = 7;  //slow rate
    ftype = 3;
    flag1 = true;
    flag2 = true;
//    count1 = 1200;
//    count2 = 2500;
    lcd.setCursor(9, 1);
       lcd.print("rt:H1+2");
       //lcd.setCursor(15, 1);
       //lcd.print(rate);
   } 
  if (key) {
    Serial.println(key);

    if (key >= '0' && key <= '9') {     // only act on numeric keys
      inputString += key; 
      Serial.println(inputString);
      lcd.setCursor(0, 1);
      lcd.print(inputString);
// append new character to input string
    } else if (key == '#') {
      if (inputString.length() > 0) {
        inputInt = inputString.toInt(); // YOU GOT AN INTEGER NUMBER
        inputString = "";               // clear input
        // DO YOUR WORK HERE
        sp = inputInt;
        Serial.println("SP = "); Serial.println(sp);
      
       lcd.setCursor(0, 1);
       lcd.print("SP: ");
       lcd.setCursor(4, 1);
       lcd.print(sp,0);
        
      }
    } else if (key == '*') {
      inputString = ""; // clear input
      lcd.init(); // clear display
      lcd.setCursor(0, 0);       // position to display
      lcd.print("Enter SP:");
    }
   }
 }
}
// Poll the assigned pin for conversion status

void pollAlertReadyPin() {
  for (uint32_t i = 0; i < 100000; i++)
    if (!digitalRead(alertReadyPin)) return;
  Serial.println("Failed to wait for AlertReadyPin, it's stuck high!");
}  

void get_temp(){
 
  float l, z, r;
    
// The below method sets the mux and gets a reading
    Serial.print("Alert/RDY "); Serial.println(digitalRead(alertReadyPin));
    Serial.println();

    adc0.setMultiplexer(ADS1115_MUX_P3_NG);
    adc0.setGain(ADS1115_PGA_2P048);
    adc0.triggerConversion();
    pollAlertReadyPin();
    Serial.print("A3: "); Serial.print(adc0.getMilliVolts(false),3); Serial.print("mv ");
    
// ++++++++++ may adjust voltage and resistance here ++++++++++++
    r=adc0.getMilliVolts(false)/1000/((5.03-(adc0.getMilliVolts(false)/1000))/100000);

    z = .0004074411144 + .0003238476254*log(r) -.00000005422314538*pow(log(r),3);
    
// +++++++++ add offset temp here to calibrate ambient +++++++++++    
    temp3 = (1/z - 273)*1.8 + 32; 
     
    Serial.print("Amb: "); Serial.print(temp3);
    Serial.println();

  adc0.setMultiplexer(ADS1115_MUX_P0_NG);
  adc0.setGain(ADS1115_PGA_0P256);
 
      adc0.triggerConversion();
      pollAlertReadyPin();
  
      l = adc0.getMilliVolts(false);
      
      delay(10);

  Serial.print("A0: "); Serial.print(l,4); Serial.print(" mV  ");
  l = l / 1000 ;  //equation needs volts, not millivolts
 
  temp = .226584602 + l * (24152.109 + l * (67233.4248 + l * (2410340.682 + l * (-860963914.9 + l * (4.83506e10 + l * (-1.18452e12 + l * (1.3869e13 - 6.33708e13 * l)))))));
 
  temp = (temp * 1.8) + temp3; 
  
   if (temp < 700){
        temp = temp+(temp/700*32);
    }else{
        temp = temp+ 32;
    }
    
   Serial.print("Temp: "); Serial.print(temp, 1); Serial.print("  ");
   
   return;
}

void hold_temp(float hd_tp, short int count, short int dch, short int dcl){
  Holding:
      get_temp();
      if (count > 0){
          if (temp <= hd_tp){
            dc = dch;
          }else{
            dc = dcl;
          }  
       analogWrite(pwr,dc);
      }
     count = count - 1;
     //Serial.print("Temp: ");Serial.print(temp);
     Serial.print("  Ct: "); Serial.print(count); Serial.print("  Dc  ");Serial.print(dc); //;
     Serial.print('\n');
    lcd.init(); // clear display
    lcd.setCursor(0,0);
    lcd.print("Ct: ");
    lcd.setCursor(4,0);
    lcd.print(count);
    lcd.setCursor(8,0);
    lcd.print(temp,1);
    lcd.setCursor(15,0);        // position to display
    lcd.print("F"); // text to display
    lcd.setCursor(0,1);
    lcd.print("Dc:");
    lcd.setCursor(4,1);
    lcd.print(dc);
    lcd.setCursor(8,1);
    lcd.print("SP:");
    lcd.setCursor(12,1);
    lcd.print(sp,0);
     if (count > 0){
          goto Holding;
        }else{
          analogWrite(pwr,0);
          lcd.init(); // clear display
      }
 return;        
}
/*****************MAIN LOOP***********************/
void loop() {
  get_temp();
  if (temp < 200){
        dc = ldc;
    }else{
        if (temp < 1300){
           dc = temp/6;
        }
        if (temp < 1100){
           dc = temp/rate;  
        }
    }
 if (temp >= 1300){
     dc = 245;
 }
 
 analogWrite(pwr,dc);

 Serial.print("DC: "); Serial.print(dc); Serial.print("  ");
 fdc = dc;  //convert to float
 Serial.print((fdc/255)*100,1);Serial.print("%");Serial.print("  SP: "); Serial.print(sp);
 Serial.print("\n"); Serial.print("Flag1: "); Serial.print(flag1); Serial.print("  Flag2: "); Serial.print(flag2);
 delay(2000);
  
  lcd.init(); // clear display
  //delay(1000);
  lcd.backlight();
  lcd.setCursor(0, 0);       // position to display
  lcd.print("Amb:");
  lcd.print(temp3,0);
  lcd.setCursor(4, 0);        // position to display
  lcd.setCursor(7, 0);       // position to display
  lcd.print("Temp:");
  lcd.setCursor(12, 0);       // position to display
  lcd.print(temp,0);
  //lcd.setCursor(30, 13);        // position to display
  //lcd.println(" F"); // text to display
  lcd.setCursor(0, 1);       // position to display
  lcd.print("DC: ");
  lcd.setCursor (3, 1);        // position to display
  lcd.print(((fdc/255)*100),0); // text to display
  lcd.setCursor(5, 1);        // position to display
  lcd.println("%"); // text to display
  lcd.setCursor (6,1);        // position to display
  lcd.println(" SP:"); // text to display
  lcd.setCursor (10,1);
  lcd.print(sp,0);
  lcd.setCursor (15,1);
  lcd.print(ftype);
   
  if (flag1 == true){
    if (temp >= 1112){
      flag1 = false;
      hold_temp(1112, 1200, 200, 100);
      }else{
      goto Jump; 
     }
    } 

  if (flag2 == true){
    if (temp >= 1250){
      flag2 = false;
      hold_temp(1250, 1200, 220, 120);
      }else{
      goto Jump; 
     }
    }
     
  if (temp >= sp){
      hold_temp(sp, 500, 220, 120);
      }else{
      goto Jump; 
     }
  
  Cycle:
    get_temp();
    analogWrite(pwr,0);
    Serial.print("Cooling: ");Serial.print(temp);Serial.print("\n");
    delay(2000);
    lcd.init(); // clear display
    lcd.setCursor(0,0);
    lcd.print("Cooling: ");
    lcd.setCursor(5,1);
    lcd.print(temp,1);
    lcd.setCursor(11,1);        // position to display
    lcd.print(" F"); // text to display

    if(temp <= 900){
       if (flaga == false){
         hold_temp(900, 1200, 100, 0);
         flaga = true;
       }
    }

    goto Cycle;
    
  Jump:
  
  Serial.println(digitalRead(alertReadyPin));
  
  }
  
